function [EDR,F,T] = compute_edr(rir,Fs,frameSizeMS,overlap);
% adapted from http://ccrma.stanford.edu/%7Ejos/vguitar/

% define STFT parameters
minFrameLen = Fs*frameSizeMS/1000; %frameSizeMS is the framelength in ms
frameLen = 2^nextpow2(minFrameLen); % frame length = fft size
frameWindow = hann(frameLen);

%compute spectrogram and energy
[B,F,T] = specgram(rir,frameLen,Fs,frameWindow,round(overlap*frameLen));
[nBins,nFrames] = size(B);
B_energy = B.*conj(B);

%compute EDR (in dB)
EDR = zeros(nBins,nFrames);
for i=1:nBins %compute EDC for each frequency band
    EDR(i,:) = 10*log10(abs(fliplr(cumsum(fliplr(B_energy(i,:))))));
end
EDR = EDR - max(max(EDR)); %normalize at 0 dB