function y = reverb_fdn(x,Fs,Tr,A,b,c,d,m);
% x: input signal; A: NXN feedback matrix; b: Nx1 array of input weights;
% c: 1XN array of output weights; d: scalar weight for input-to-output contrib.
% m: N-dim array of line delays (in samples) 

N=size(A,1); %dimension of the FDN
delaylines = zeros(max(m),N); %create and initialize N delay lines
[num_H,den_H,num_E,den_E] = lossy_fdn(Fs,Tr,m); %initialize lossy components

y = zeros(size(x)); %initialize output signal
for n = 1:length(x)   %audio cycle
    Y=zeros(N,1); % Y is the array of N signals after the lowpass filters
    for i=1:N   Y(i)= filter(num_H(i), den_H(i), delaylines(m(i),i) ); end    
    y(n)= filter(num_E, den_E, c*Y) +d*x(n);      %compute output
    linein =b*x(n) + A*Y;      %compute new input to lines
    delaylines = circshift(delaylines,1); %circular shift lines
    delaylines(1,:) = linein;               %write lines    
if(mod(n,round(length(x)/20))==0) fprintf('%d%%\n',round(n/length(x)*100)); end
end