% Test the FDN reverberator: parameters taken from smith and gardner

wavfile= '../../../samples/voice_scream.wav';   % input wave file
[x,Fs,Nbits]=wavread(wavfile);

%x=1; %impulse!!!

%%%%%%%%%%%%%%%%%%%% Define reverberation time (in s) %%%%%%%%%%%%%%%%%%%%
Tr= 4;

%%%%%%%%%%%%%%%%%%%%%%%%% Define feedback matrix A %%%%%%%%%%%%%%%%%%%%%%%
% Example 1: Stautner Puckette
g = 0.9; A_SP=g/sqrt(2)*[0 1 1 0;-1 0 0 -1;1 0 0 -1;0 1 -1 0];
% Example 2: Householder matrices
HH=(1/2)*[1  -1  -1  -1;   -1   1 -1  -1 ;  -1  -1  1  -1 ;  -1  -1  -1  1 ];
A_HH= (1/2)*[HH -HH -HH -HH; -HH HH -HH -HH; -HH -HH HH -HH; -HH -HH -HH HH];
% Example 3: 16x16 Hadamard 
A_Had=(1/4)*hadamard(16);

%Choose the matrix you like!
A=A_HH;
N=size(A,1);  %dimension of the FDN

%%%%%%%%%%%%%%%%%%%%%%%%% Define delays %%%%%%%%%%%%%%%%%%%%%%%

totdelay = 1*N/16; % a total delay of 1 s with N=16 is reasonable
primegap=20*16/N;  %empirical guess
myprimes=primes(totdelay*Fs/N*2);                     %define m as prime 
[fake,primei] = min(abs(myprimes-totdelay*Fs/N));     %numbers whose sum is
m=myprimes((1:N)*primegap+primei-round(N/2)*primegap);%approx. totdelay

%m = round([50 56 61 68 72 78]*Fs/1000); % like moorer
%m=[1289 1387 1473 1567 1637 1733 1853 1922 2000 2123 2283 2356 ...
%    2753 2894 3435 4323];%-[1200:-100:-300];

%%%%%%%%%%%%%%%%%%%%%%%%% Define weights %%%%%%%%%%%%%%%%%%%%%%%
b= ones(N,1);
c= ones(1,N);
d=1;

%%%%%%%%%%%%%% preprocess input signal %%%%%%%%%%%%%%%%%%%%%
if size(x,2)>1 x=x(:,2); end  %if x is stereo use only one channel
x=[x;zeros(Tr*Fs,1)];  %add zeros to x to hear decaying reverberation tail


%%%%%%%%%%%%%% compute fdn output %%%%%%%%%%%%%%%%%%%%%
y = reverb_fdn(x,Fs,Tr,A,b,c,d,m); 

y=y/max(1.1*abs(y));
wavwrite(y,Fs,Nbits,'y_fdn.wav');

