% Test the Moorer reverberator: parameters taken from Moorer (1979)

global Fs;

wavfile= '../../../samples/la.wav';   % input wave file
[x,Fs,Nbits]=wavread(wavfile);

%x=1; %impulse!!!

%%%%%%%%% early reflection parameters %%%%%%%%%%%%%%%%%%%
%%%% FIR with 6 taps
%m_E = round([0 0.0199 0.0354 0.0389 0.0414 0.0699 0.0796]*Fs);
%a_E = [1, 1.02 0.818 0.635 0.719 0.267 0.242];

%%%% FIR with 18 taps 
m_E = round([0, .0043, .0215, .0225, .0268, .0270, .0298, .0458, .0485, ...
  .0572, .0587, .0595, .0612, .0707, .0708, .0726, .0741, .0753, .0797]*Fs);
a_E = [1, .841, .504, .491, .379, .380, .348, .289, .272, ...
    .192, .193, .217, .181, .180, .181, .176, .142, .167, .134];
 
 
%%%%%%%%%%%%%%% late reverberation parameters %%%%%%%%%%%%%%%%%%
m_H = round([50 56 61 68 72 78]*Fs/1000); % delays of combs
g1_H = [0.46 0.48 0.50 0.52 0.53 0.55]*Fs/50000; % g1's of low-passes H_lp
m_A = round(6*Fs/1000);      %all-pass delay
g_A = 0.7;                   %all-pass gain
Tr = 2;                      %reverberation time
g_mix = 1;                   %percentage of reverberated sound mixed 
                             %  with dry sound / early reflections
%%%%%%%%%%%%%% preprocess input signal %%%%%%%%%%%%%%%%%%%%%
if size(x,2)>1 x=x(:,2); end  %if x is stereo use only one channel
x=[x;zeros(Tr*Fs,1)];  %add zeros to x to hear decaying reverberation tail


%%% combination of direct signal and late reverb only
%y = (1-g_mix)*x + g_mix*reverb_moorer(x,Tr,m_H,g1_H,m_A,g_A);

%%% early reflections only
%y = reverb_earlyrefl(x, m_E, a_E);

%%% early refl and late reverb according to moorer (1979) scheme
y = reverb_moorer_earlyrefl(x, Tr, m_E, a_E, m_H, g1_H, m_A, g_A, g_mix);

y=y/max(1.05*abs(y));
wavwrite(y,Fs,Nbits,'y_moorer.wav');

